






// Motivo por não ter utilizado este código na addon atual:
// "Desejo que este código seja mais refinado e otimizado até o lançamento da versão final do Extensus.
// Reconheço que o Auto Harvest ainda precisa de melhorias, mas peço que aguardem pela versão final. Obrigado pela compreensão!"






import { world, system } from "@minecraft/server"
import { MessageFormData, ModalFormData } from "@minecraft/server-ui";
import { itemTeleporterStructure, updateDynamicData, writeDynamicData, fetchDynamicData, randomNumber } from "./functions.js"

const dynamicID = "item_teleporter:"

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('ext:item_teleporter_component', {
        onTick: itemTeleporterTick,
        beforeOnPlayerPlace: itemTeleporterPlace,
        onPlayerInteract: itemTeleporterMenu,
        onPlayerDestroy: itemTeleporterDestroy
    })
});

function itemTeleporterTick(event) {
    world.getDynamicPropertyIds().forEach(objDynamic => {
        if (objDynamic.startsWith(dynamicID)) {
            const Dimension = world.getDimension(event.block.dimension.id)
            const dynamicData = fetchDynamicData(objDynamic)
            if (dynamicData[0].switch) {
                const itemTeleporterLocation = JSON.parse(objDynamic.replace(dynamicID, ""))
                for (let i = 0; i < 20; i++) {
                    Dimension.spawnParticle("minecraft:end_chest", { x: itemTeleporterLocation.x + 0.5, y: itemTeleporterLocation.y + randomNumber(0, 0.8, false), z: itemTeleporterLocation.z + 0.5 })
                }
                Dimension.runCommand(`tp @e[type=item,x=${itemTeleporterLocation.x},y=${itemTeleporterLocation.y + 1},z=${itemTeleporterLocation.z},r=1.5] ${dynamicData[0].intX} ${dynamicData[0].intY} ${dynamicData[0].intZ}`)
            }
        }
    })
}

function itemTeleporterPlace(event) {
    const [player, block] = [event.player, event.block]
    const dynamicFormat = `${dynamicID}${JSON.stringify(block.location)}`
    updateDynamicData(dynamicFormat, itemTeleporterStructure(player, block))
}

function itemTeleporterMenu(event) {
    const maxDistance = 30;
    let blockLocation;
    let dynamicName;
    world.getDynamicPropertyIds().forEach(objDynamic => {
        if (objDynamic.startsWith(dynamicID)) {
            const itemTeleporterLocation = JSON.parse(objDynamic.replace(dynamicID, ""))
            if (JSON.stringify(itemTeleporterLocation) == JSON.stringify(event.block.location)) {
                blockLocation = itemTeleporterLocation
                dynamicName = objDynamic
            }
        }
    })

    const dynamicData = fetchDynamicData(dynamicName);

    const yFixNegative = Math.max(blockLocation.y - maxDistance, -59);
    const yFixPositive = Math.min(blockLocation.y + maxDistance, 319);

    const xFixNegative = Math.max(blockLocation.x - maxDistance, -blockLocation.x - maxDistance);
    const xFixPositive = Math.min(blockLocation.x + maxDistance, blockLocation.x + maxDistance);

    const zFixNegative = Math.max(blockLocation.z - maxDistance, -blockLocation.z - maxDistance);
    const zFixPositive = Math.min(blockLocation.z + maxDistance, blockLocation.z + maxDistance);

    const ui = new ModalFormData();

    if (dynamicData[0].private) {
        if (event.player.name == dynamicData[0].owner) {
            blockConfigUI();
            showMain();
        } else {
            event.player.sendMessage("§cVocê não tem Permissão");
        }
    } else {
        blockConfigUI();
        showMain();
    }

    function blockConfigUI() {
        ui.title("Teleportador de Item");
        ui.toggle("Teleportador Habilitado", dynamicData[0].switch);
        ui.toggle("Privar?", dynamicData[0].private);
        ui.textField(`Coordenada X`, `${xFixNegative} => ${xFixPositive} // Atual: ${dynamicData[0].intX}`);
        ui.textField(`Coordenada Y`, `${yFixNegative} => ${yFixPositive} // Atual: ${dynamicData[0].intY}`);
        ui.textField(`Coordenada Z`, `${zFixNegative} => ${zFixPositive} // Atual: ${dynamicData[0].intZ}`);
    }

    function showMain() {
        ui.show(event.player).then((data) => {
            const [toggle1, toggle2, textField1, textField2, textField3] = data.formValues;

            if (data.cancelationReason !== "UserClosed") {

                if (toggle1 !== dynamicData[0].switch) {
                    dynamicData[0].switch = toggle1;
                }

                if (toggle2 !== dynamicData[0].private) {
                    if (dynamicData[0].owner === event.player.name) {
                        dynamicData[0].private = toggle2;
                    } else {
                        event.player.sendMessage("§cVocê não tem Permissão para privar este bloco.");
                    }
                }

                if (!isNaN(Number(textField1)) && typeof textField1 === "string") {
                    if (textField1.length > 0) {
                        const newX = Math.max(Math.min(Number(textField1), xFixPositive), xFixNegative);
                        dynamicData[0].intX = newX;
                    }
                } else {
                    event.player.sendMessage("§cValor inválido no campo de texto 1 (X).");
                }

                if (!isNaN(Number(textField2)) && typeof textField2 === "string") {
                    if (textField2.length > 0) {
                        const newY = Math.max(Math.min(Number(textField2), yFixPositive), yFixNegative);
                        dynamicData[0].intY = newY;
                    }
                } else {
                    event.player.sendMessage("§cValor inválido no campo de texto 2 (Y).");
                }

                if (!isNaN(Number(textField3)) && typeof textField3 === "string") {
                    if (textField3.length > 0) {
                        const newZ = Math.max(Math.min(Number(textField3), zFixPositive), zFixNegative);
                        dynamicData[0].intZ = newZ;
                    }
                } else {
                    event.player.sendMessage("§cValor inválido no campo de texto 3 (Z).");
                }

                writeDynamicData(dynamicName, dynamicData);
            }
        });
    }
}

function itemTeleporterDestroy(event) {
    world.getDynamicPropertyIds().forEach(objDynamic => {
        if (objDynamic.startsWith(dynamicID)) {
            const Dimension = world.getDimension(event.block.dimension.id)
            const dynamicData = fetchDynamicData(objDynamic)
            const itemTeleporterLocation = JSON.parse(objDynamic.replace(dynamicID, ""))
            if (JSON.stringify(itemTeleporterLocation) == JSON.stringify(event.block.location)) {
                if (dynamicData[0].private) {
                    if (dynamicData[0].owner == event.player.name) {
                        world.setDynamicProperty(`${dynamicID}${JSON.stringify(event.block.location)}`, null)
                    } else {
                        Dimension.setBlockType(itemTeleporterLocation, "ext:item_teleporter")
                        event.player.sendMessage("§cVocê não tem Permissão para quebrar este bloco.")
                    }
                } else {
                    world.setDynamicProperty(`${dynamicID}${JSON.stringify(event.block.location)}`, null)
                }
            }
        }
    })
}